Unit ASV1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAS10_p;

procedure ASV1R(var X :Array of Real; var Y :Array of Real;
                var B :Array of Real; N :Integer;
                var RAB :Array of Real; var IERR :Integer);

implementation

procedure ASV1R(var X :Array of Real; var Y :Array of Real;
                var B :Array of Real; N :Integer;
                var RAB :Array of Real; var IERR :Integer);
var
I,J,N1I,N1,K,K1 :Integer;
XX,T,TB,S :Real;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_10,_20,_30,_40,_50,_60,_80,_70;
begin
IERR := 0;
if ( N <> 1 ) 
 then goto _10;
Y[0] := B[0];
goto _70;
_10:
for I:=1 to N do
 begin
  RAB[I-1] := ZERO;
_20:
 end;
RAB[N-1] := -X[0];
for I:=2 to N do
 begin
  XX := -X[I-1];
  N1I := N+1-I;
  N1 := N-1;
  for J:=N1I to N1 do
   begin
    RAB[J-1] := RAB[J-1]+XX*RAB[J+0];
_30:
   end;
  RAB[N-1] := RAB[N-1]+XX;
_40:
 end;
for I:=1 to N do
 begin
  XX := X[I-1];
  T := ONE;
  TB := ONE;
  S := B[N-1];
  K := N;
  for J:=2 to N do
   begin
    K1 := K-1;
    TB := RAB[K-1]+XX*TB;
    S := S+B[K1-1]*TB;
    T := XX*T+TB;
    K := K1;
_50:
   end;
  if ( T = ZERO ) 
   then goto _80;
  Y[I-1] := S/T;
_60:
 end;
goto _70;
_80:
IERR := 65;
UTAS10(IERR,5);
_70:
end;

end.
